/*****************************************************************************
 * Copyright (c) 2001, Ravikanth Dronamraju
 * Distributed under the GNU General Public License version 2
 *****************************************************************************
 * $Id:$
 *****************************************************************************/

#define RRD_GEN_EXPORTS
#include "mod_rrdtool.h"

#include <stdio.h>
#include "getopt.h"
#include "rrd.h"

extern int __getopt_initialized;



/*****************************************************************************
	optind and __getopt_initialized are usually set upon entry of the process.
	In the non-shared use, the process exits after any one of the below functions
	has completed, so that normally these functions start with optind = 1; and
	__getopt_initialized = 0;.
	In the case of a shared module,... these have to be reset prior to entry for
	any unique request (as is done below).
 *****************************************************************************/
 

RRD_EXPORT(int) mod_rrd_create(int argc, char **argv)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_create(argc, argv);
}

RRD_EXPORT(int) mod_rrd_update(int argc, char **argv)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_update(argc, argv);
}

RRD_EXPORT(int) mod_rrd_graph(int argc, char **argv, char ***prdata, int *xsize, int *ysize)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_graph(argc, argv, prdata, xsize, ysize);
}


RRD_EXPORT(int) mod_rrd_fetch(int argc, char **argv, time_t *start,time_t *end, 
								unsigned long  *step, unsigned long  *ds_cnt, char ***ds_namv, rrd_value_t **data) 
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_fetch(argc, argv, start, end, step, ds_cnt, ds_namv, data); 
}

RRD_EXPORT(int) mod_rrd_restore(int argc, char **argv)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_restore(argc, argv);
}

RRD_EXPORT(int) mod_rrd_dump(int argc, char **argv)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_dump(argc, argv);
}

RRD_EXPORT(int) mod_rrd_tune(int argc, char **argv)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_tune(argc, argv);
}

RRD_EXPORT(time_t) mod_rrd_last(int argc, char **argv)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_last(argc, argv);
}

RRD_EXPORT(int) mod_rrd_resize(int argc, char **argv)
{
	optind = 1;
	__getopt_initialized = 0;
	return rrd_resize(argc, argv);
}

RRD_EXPORT(void) mod_rrd_clear_error(void)
{
	rrd_clear_error();
}

RRD_EXPORT(int)	mod_rrd_test_error(void)
{
	return rrd_test_error();
}

RRD_EXPORT(char *) mod_rrd_get_error(void)
{
	return rrd_get_error();
}


